<?php
class TableDescriptor{
	public $name;
	public $columns;

    function __construct($name,$columns) {
        $this->name=$name;
        $this->columns=$columns;
    }
}

class ColumnDescriptor{
	public $name;
	public $type;
	public $isNull;
	public $key;
	public $default;

	function __construct($name,$type,$isNull,$key,$default) {
    	 $this->name=$name;
         $this->type=$type;
         $this->isNull=$isNull;
	     $this->key=$key;
	     $this->default=$default;
	}
}

class TwitterTableUpdater{
	public static function updateTable($table){
		// Check for existence.
		$result = mysql_query ('SHOW TABLES LIKE \''.$table->name."'");
		$row = mysql_fetch_array($result);
		if($row===FALSE){
			self::createTable($table);
			return;
		}
		
		$columns=array();
		foreach ($table->columns as $column)
		    $columns[$column->name]=true;
	
		// Delete obsolete columns
		$result = mysql_query ('DESCRIBE '.$table->name);
		while($row = mysql_fetch_array($result)){
			$name=$row['Field'];
			if(!isset($columns[$name])){
				echo $name.' deleted<br/>';
				if(mysql_query ('ALTER TABLE '.$table->name.' DROP COLUMN '.$name)){
					echo $name.' deleted<br/>';
				}
				else{
					echo $name.' failed to be deleted<br/>';
				}
			}
			else{
				unset($columns[$name]);
			}
		}
	
		// Add new columns
		foreach ($table->columns as $column) {
		    if(isset($columns[$column->name])){
		    	$columnDefinition=$column->type;
		    	if(!$column->isNull)
		    		$columnDefinition.=' NOT';
		   		$columnDefinition.=' NULL';
		   		if(isset($column->default)){
			   		$columnDefinition.=' DEFAULT '.$column->default;
		   		}
				if(mysql_query ('ALTER TABLE '.$table->name.' ADD COLUMN '.$column->name.' '.$columnDefinition)){
				    echo $column->name.' added<br/>';
				}
				else{
				    echo $column->name.' could not be added<br/>';
				}
		    }
		}
	}
	
	public static function createTable($table){
		$sql='CREATE TABLE '.$table->name;
		foreach ($table->columns as $column) {
			$definition=$column->name.' '.$column->type;
			if(!$column->isNull)
				$definition.=' NOT';
			$definition.=' NULL';
			if(isset($column->default))
				$definition.=' DEFAULT \''.$column->default."'";
			if($column->key)
				$definition.=' PRIMARY KEY';
			if(isset($columnSQL)){
				$columnSQL.=', '.$definition;
			}
			else{
				$columnSQL=$definition;
			}
		}
		if(isset($columnSQL)){
			$sql.=' ('.$columnSQL.')';
			$result=mysql_query($sql);
			if(!$result){
			    echo $table->name.' could not be created.<br/>'.mysql_error().'<br/>'.$sql;
			}
		}
		else{
		    echo $table->name.' did not have any columns defined.<br/>';
		}
	}
	
	public static function dropTable($table){
		mysql_query('DROP TABLE IF EXISTS '.$table->name);
	}
}
?>